/* Feb 8/91- Taken from Bjarne Stroustrup book C ++ 						*/
/* Capilano Computing Systems Limited.										*/

  
/* This class is used to create and handle double 							*/
/* linked lists. This class will allow an object to be on multiple 			*/
/* lists at the same time. The list is made up of dlink's which in turn 	*/
/* point to the users data													*/

#ifndef DLIST_H
#define DLIST_H

#include "DLink.h"
#include "TList.h"

//manage a doubly linked list

class TDList :public  TList
{

private:
	TDLink 	*fLast;
	TDLink 	*fCurr;

public:

   	// construct empty list 
   
   	TDList();
   
   	// construct a list with one entry 
   
   	TDList(TListObject* a);
   
   // Create list and init it to oldlist
   
   	TDList(TDList &olTDList);
	
	~TDList();
	
	
   
	int IsEmpty() { return fLast == 0;}

	// clear list to empty state
	
	void Clear();
	
	//set current pointer to the ends of the list

	void Reset() { fCurr = 0;}

	
	
	// move around the list, leaving the links there

	int Next (TListObject** e);
	int Prev (TListObject** e);

	//manipulate around the list, removing the links

	int GetNext(TListObject** e);
	int GetPrev(TListObject** e);

	//manipulate around the beginning
	// and end of the list

	void Insert(TListObject* e);
	void Append(TListObject* e);

	// manipulate around the current entry

	void InserThere(TListObject* e);
	void AppendHere(TListObject* e);
};


#endif